SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
IF OBJECT_ID(N'dbo.usp_LoadXML') IS NOT NULL
    DROP PROCEDURE dbo.usp_LoadXML;
GO
-- =============================================
-- Author:		Aaron N. Cutshall
-- Create date: 29-Jul-2017
-- Description:	Load sample XML
-- =============================================
CREATE PROCEDURE [dbo].[usp_LoadXML]
AS
BEGIN
	DECLARE @xmlStores xml = '<?xml version="1.0" encoding="UTF-8"?>
						<ddExample>
							<measure name="Extended Extended Warranty Purchased">
								<denominator name="Extended Warranty Available" logical="and">
									<rule name="Qualifying Purchase" logical="or">
										<fact name="Major Appliance Purchased"/>
										<fact name="Major Electronic Purchased"/>
										<fact name="Major Power Tool Purchased"/>
									</rule>
									<fact name="Mfg Warranty Available"/>
									<rule name="Mfg Warranty Not Included" logical="not">
										<fact name="Mfg Warranty Included"/>
									</rule>
								</denominator>
								<numerator name="Extended Warranty Was Purchased" logical="and">
									<fact name="Extended Warranty Purchased"/>
								</numerator>
							</measure>
							<measure name="Frequent Customer">
								<denominator name="Qualified Purchase Frequency" logical="or">
									<fact name="One Purchase per Week for 4 Weeks"/>
									<fact name="Four Purchases per Month for 2 Months"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter"/>
								</denominator>
								<numerator name="Qualified Purchase Amount" logical="or">
									<fact name="Avg Purchase per Week GE $250"/>
									<fact name="Avg Purchase per Month GE $500"/>
									<fact name="Avg Purchase per Quarter GE $1000"/>
								</numerator>
							</measure>
							<store name="Store TOS">
								<customer lastName="Kirk" firstName="James">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="1"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="1"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="0"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="0"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
								<customer lastName="Spock">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="1"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="1"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="0"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="1"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="0"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="1"/>        
								</customer>
								<customer lastName="McCoy" firstName="Leonard">
									<fact name="Major Appliance Purchased" isTrue="1"/>
									<fact name="Major Electronic Purchased" isTrue="0"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="0"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="1"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="1"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
								<customer lastName="Scott" firstName="Montgomery">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="0"/>
									<fact name="Major Power Tool Purchased" isTrue="1"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="1"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="1"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="1"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="0"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="1"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="1"/>        
								</customer>
							</store>
							<store name="Store TNG">
								<customer lastName="Picard" firstName="Jean-Luc">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="1"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="1"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="1"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="1"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
								<customer lastName="Riker" firstName="William">
									<fact name="Major Appliance Purchased" isTrue="1"/>
									<fact name="Major Electronic Purchased" isTrue="1"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="1"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="1"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="1"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="1"/>        
								</customer>
								<customer lastName="Data">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="0"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="0"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="0"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="0"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
								<customer lastName="LaForge" firstName="Geordi">
									<fact name="Major Appliance Purchased" isTrue="1"/>
									<fact name="Major Electronic Purchased" isTrue="1"/>
									<fact name="Major Power Tool Purchased" isTrue="1"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="1"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="1"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="1"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="1"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="1"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="1"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="1"/>        
								</customer>
							</store>
							<store name="Store DS9">
								<customer lastName="Sisko" firstName="Benjamin">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="1"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="1"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="1"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
								<customer lastName="Kira" firstName="Nerys">
									<fact name="Major Appliance Purchased" isTrue="1"/>
									<fact name="Major Electronic Purchased" isTrue="0"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue=""/>
									<fact name="Mfg Warranty Included" isTrue="1"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="1"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="1"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
								<customer lastName="Bashir" firstName="Julian">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="0"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="0"/>
									<fact name="Mfg Warranty Included" isTrue="0"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="0"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="0"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
								<customer lastName="Dax" firstName="Jadzia">
									<fact name="Major Appliance Purchased" isTrue="0"/>
									<fact name="Major Electronic Purchased" isTrue="1"/>
									<fact name="Major Power Tool Purchased" isTrue="0"/>
									<fact name="Extended Warranty Available" isTrue="1"/>
									<fact name="Mfg Warranty Included" isTrue="1"/>
									<fact name="Extended Warranty Purchased" isTrue="0"/>
									<fact name="One Purchase per Week for 4 Weeks" isTrue="0"/>
									<fact name="Four Purchases per Month for 2 Months" isTrue="0"/>
									<fact name="Eight Purchases per Quarter for 1 Quarter" isTrue="0"/>
									<fact name="Avg Purchase per Week GE $250" isTrue="0"/>
									<fact name="Avg Purchase per Month GE $500" isTrue="0"/>
									<fact name="Avg Purchase per Quarter GE $1000" isTrue="0"/>        
								</customer>
							</store>
						</ddExample>';

	IF OBJECT_ID('dbo.tbl_Measure', 'U') IS NOT NULL DROP TABLE dbo.tbl_Measure;
	CREATE TABLE dbo.tbl_Measure (
		MeasureId INT NOT NULL IDENTITY(1,1),
		MeasureName VARCHAR(64) NULL,
		DenRuleId INT NULL,
		NumRuleId INT NULL
		);

	IF OBJECT_ID('dbo.tbl_Fact', 'U') IS NOT NULL DROP TABLE dbo.tbl_Fact;
	CREATE TABLE dbo.tbl_Fact (
		FactId INT NOT NULL IDENTITY(1,1),
		FactName VARCHAR(64) NULL
		);

	IF OBJECT_ID('dbo.tbl_Rule', 'U') IS NOT NULL DROP TABLE dbo.tbl_Rule;
	CREATE TABLE dbo.tbl_Rule (
		RuleId INT NOT NULL IDENTITY(1,1),
		RuleName VARCHAR(64) NULL,
		ParentRuleId INT NULL,
		LogicalId TINYINT NOT NULL -- Use 1=AND, 2=OR, 3=NOT
		);

	IF OBJECT_ID('dbo.tbl_RuleFact', 'U') IS NOT NULL DROP TABLE dbo.tbl_RuleFact;
	CREATE TABLE dbo.tbl_RuleFact (
		RuleId INT NOT NULL,
		FactId INT NOT NULL
		);

	IF OBJECT_ID('dbo.tbl_Store', 'U') IS NOT NULL DROP TABLE dbo.tbl_Store;
	CREATE TABLE dbo.tbl_Store (
		StoreId INT NOT NULL IDENTITY(1,1),
		StoreName VARCHAR(64) NULL
		);

	IF OBJECT_ID('dbo.tbl_Customer', 'U') IS NOT NULL DROP TABLE dbo.tbl_Customer;
	CREATE TABLE dbo.tbl_Customer (
		CustomerId INT NOT NULL IDENTITY(1,1),
		LastName VARCHAR(64) NULL,
		FirstName VARCHAR(64) NULL,
		StoreId INT NOT NULL
		);

	IF OBJECT_ID('dbo.tbl_CustFact', 'U') IS NOT NULL DROP TABLE dbo.tbl_CustFact;
	CREATE TABLE dbo.tbl_CustFact (
		CustomerId INT NOT NULL,
		FactId INT NOT NULL,
		IsTrue BIT NOT NULL
		);

	DECLARE @iSeq INT,
			@nSeq INT,
			@xmlFrag xml,
			@DenRuleId INT,
			@NumRuleId INT;
	DECLARE @OutputTbl TABLE (Id INT);

-- Load Rule Facts -- Performs search for all facts within the node measure regardless of level (DISTINCT peforms implicit sort)
	INSERT INTO dbo.tbl_Fact (FactName)
	SELECT	DISTINCT a.value('(@name)', 'varchar(64)')
	FROM	@xmlStores.nodes('*/measure//fact') x(a);

-- Load Measures -- Loop through each individual measure to process both denominator and numerator rules
	SELECT @iSeq = 0, @nSeq = ISNULL(COUNT(*),0)
	FROM @xmlStores.nodes('*/measure') x(a);
	
	WHILE @iSeq < @nSeq BEGIN
		SET @iSeq = @iSeq + 1;

		SET @xmlFrag = @xmlStores.query('*/measure[position()=sql:variable("@iSeq")]/denominator');
		EXEC dbo.usp_LoadRule @xmlFrag, NULL, @DenRuleId OUTPUT;

		SET @xmlFrag = @xmlStores.query('*/measure[position()=sql:variable("@iSeq")]/numerator');
		EXEC dbo.usp_LoadRule @xmlFrag, NULL, @NumRuleId OUTPUT;

		INSERT INTO dbo.tbl_Measure (MeasureName, DenRuleId, NumRuleId)
		SELECT	a.value('(@name)', 'varchar(64)'),
				@DenRuleId, @NumRuleId
		FROM	@xmlStores.nodes('*/measure[position()=sql:variable("@iSeq")]') x(a);

	END

-- Load Stores -- Load each store
	INSERT INTO dbo.tbl_Store (StoreName)
	SELECT	a.value('(@name)', 'varchar(64)')
	FROM	@xmlStores.nodes('*/store') x(a);

-- Load Customers -- Load each customer with respect to each store
	INSERT INTO dbo.tbl_Customer (LastName, FirstName, StoreId)
	SELECT	a.value('(@lastName)', 'varchar(64)'),
			a.value('(@firstName)', 'varchar(64)'),
			s.StoreId
	FROM	@xmlStores.nodes('*/store/customer') x(a)
	INNER JOIN dbo.tbl_Store s
		ON s.StoreName = a.value('(../@name)', 'varchar(64)');

-- Load Customer Facts -- Load each customer fact with a lookup for each customer by name and a lookup for each fact by name
	INSERT INTO dbo.tbl_CustFact (CustomerId, FactId, IsTrue)
	SELECT	c.CustomerId,
			f.FactId,
			ISNULL(a.value('(@isTrue)', 'bit'),0)
	FROM	@xmlStores.nodes('*/store/customer/fact') x(a)
	INNER JOIN dbo.tbl_Customer c
		ON c.LastName = a.value('(../@lastName)', 'varchar(64)')
		AND ISNULL(c.FirstName,'') = ISNULL(a.value('(../@firstName)', 'varchar(64)'),'')
	INNER JOIN dbo.tbl_Fact f
		ON f.FactName = a.value('(@name)', 'varchar(64)');

-- Output all tables for demo purposes only
	select * from dbo.tbl_Measure;
	select * from dbo.tbl_Rule;
	select * from dbo.tbl_Fact;
	select * from dbo.tbl_RuleFact;
	select * from dbo.tbl_Store;
	select * from dbo.tbl_Customer;
	select * from dbo.tbl_CustFact;
END